// Problema 6: Montecarlo
// Fecha: 10/9/2019; 10 am
// Revisin: 12/9/2020; 6:11 pm
// S. Galliano.

#include "../../Programas/deposito/print.h"
#include "../../Programas/deposito/rnd.h"
#include <iostream>
#include <array>
#include <ctime>

const double LsobreC = 3.141596; // es la razn ajustada
const double ERR     = 0.0001;   // +/- mximo error tolerado
const int VECES      = 5000;     // cantidad de rplicas
const int N          = 1000;     // cantidad de tiradas/rplica

//  genera la probabilidad de sacar 1 de (0..1) en n intentos
double prob();

int main() {
    //  variables
    long double pi = 0; // valor generado
    double error   = 0; // error cometido
    short pase     = 0; // cuenta de los pases
    std::string resp;   // respuesta ajustada
    srand( time( 0 ) ); // una nueva semilla cada vez
    std::cout <<
              "Ejercicio 6: generando el valor de Pi\n\n"
              "Cada pase son " << VECES << " r\202plicas y el c\240lculo\n"
              "se hace hasta tener un error de  " << ERR << "%.\n\n";

    do {
        for ( int i = 0; i < VECES; ++i ) pi += 2 * prob() * LsobreC;
        pi /= VECES; // valor promedio
        error = ( pi - 3.141596 ) / 3.141596;
        ++pase;
        std::cout << "Pase "  << pase << '\r';
    } while ( std::abs( error ) > ERR ); // do-while

    1 == pase
        ? std::cout << "\n\nEn un pase:\n"
        : std::cout << "\n\nEn " << pase << " pases:\n";

    std::cout << std::fixed  <<
              "  Valor base de Pi  = " << 3.141596 << '\n' <<
              "  Valor generado Pi = " << pi       << '\n' <<
              "  Error cometido    = " << error    << " %\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}

//  genera la probabilidad de tener num xitos en n tiradas
double prob() {
    std::array<bool, N> tiradas;
    RELLENA_I( tiradas, false, true );
    //  cuenta todas las veces que sali verdadero
    int num = std::count( tiradas.begin(), tiradas.end(), true );
    return static_cast<double>( num ) / N;
}
