//  busqueda.cpp: definiciones para el problema 6
//  Fecha: 28/2/2020; 8:33 pm
//  Por: S. Galliano.
#include "busqueda.h"
#include <algorithm>
typedef std::pair<Vct::iterator, Vct::iterator> Par;
using std::make_pair;

//  Estrategia:
//    buscar si la clave est:
//    NO: retornar el par (0,0)
//    SI: determinar el mayor ndice
//        determinar el menor ndice
//        calcular dnde est el ndice (inicio a menor)
//        calcular las veces entre menor y mayor
//        retornar el par (dnde + 1, veces)

Resp posiciones( int clave, const Vct &vect ) {
    Par pos;
    Vct::const_iterator end( vect.end() );

    if ( not binary_search( vect.begin(), end, clave ) ) return make_pair( 0, 0 );

    Vct::const_iterator i = upper_bound( vect.begin(), end, clave );
    Vct::const_iterator j = lower_bound( vect.begin(), end, clave );
    Vct::difference_type donde = distance( vect.begin(), j ); // ndice
    Vct::difference_type veces = distance( j, i );            // veces
    return make_pair( ++donde, veces );                       // posicin, una ms
}
