//  datos.cpp: definiciones de la estructura de datos para el problema 8
//  Fecha: 23/1/2020; 1:24 pm
//  Revisin: 12/9/2020; 6:36 pm
//  Por: S. Galliano.
#include "datos.h"
#include <utility>
using std::make_pair;

//  carga la base de datos: 19 preposiciones
void cargar( Dicc & d ) {
    d.insert( make_pair( "a", "Direcci\242n de movimiento, intervalos de tiempo o espacio." ) );
    d.insert( make_pair( "ante", "Antecedencia, dificultad, comparaci\242n." ) );
    d.insert( make_pair( "bajo", "Sometimiento o posici\242n relativa." ) );
    d.insert( make_pair( "cabe", "Proximidad o cercan\241a." ) );
    d.insert( make_pair( "con", "Acompa\244amiento, aparejamiento, con que se hace algo." ) );
    d.insert( make_pair( "contra", "Enfrentamiento, apoyatura, entrega a cambio de algo." ) );
    d.insert( make_pair( "de", "Posesi\242n, cualidad, recipiente." ) );
    d.insert( make_pair( "desde", "Punto de origen en tiempo o espacio, donde se acciona." ) );
    d.insert( make_pair( "en", "Estancia, posici\242n, momento hist\242rico, transici\242n." ) );
    d.insert( make_pair( "entre", "Separaci\242n de dos cosas, estado intermedio, pertenencia a grupo." ) );
    d.insert( make_pair( "hacia", "Direcci\242n, objetivo, orientaci\242n, proximidad en tiempo o espacio." ) );
    d.insert( make_pair( "hasta", "L\241mite, nivel, inclusi\242n, expresi\242n de despedida." ) );
    d.insert( make_pair( "para", "Objetivo, utilidad, uso o destino de algo, aptitud." ) );
    d.insert( make_pair( "por", "Lugar, fecha aproximada, tiempo de un hecho o acci\242n." ) );
    d.insert( make_pair( "seg\243n", "Origen de un conocimiento, costumbre, ley o norma." ) );
    d.insert( make_pair( "sin", "Falta, carencia u omisi\242n de algo, sobre todo en gastos." ) );
    d.insert( make_pair( "so", "Una cosa bajo otra. S\242lo se utiliza en so capa, so pretexto o so pena." ) );
    d.insert( make_pair( "sobre", "Encumbramiento, posici\242n, concepto, aproximaci\242n de fechas o n\243meros." ) );
    d.insert( make_pair( "tras", "Precedencia, ocultamiento, persecuci\242n, b\243squeda, a\244adidura de info." ) );
}

#include <iostream>
using std::cout;
#include <iomanip>
using std::setw;
using std::left;
using std::right;
using std::setfill;

//  dos funciones auxiliares:

void mostrarTitulo() {
    cout << "\nPrep.\tSignificado\n"
         << setfill( '-' ) << setw( 80 ) << '\n' << setfill( ' ' );
}

void cerrar() {
    cout << setfill( '-' ) << setw( 80 ) << '\n' << setfill( ' ' ) << '\n';
}

//  muestra todas las preposiciones
void mostrarTodas( const Dicc & d ) {
    mostrarTitulo();

    for ( auto x : d )
        cout << left  << x.first << '\t'
             << right << x.second << '\n';
    cerrar();
}

//  muestra una preposici\242n
void mostrarUna( Str clave, const Dicc & d ) {
    if ( 0 == d.count( clave ) ) throw ERR;
    Dicc::const_iterator pos = d.lower_bound( clave );
    mostrarTitulo();
    cout << left << setw( 9 ) << pos->first << right << pos->second << '\n';
    cerrar();
}
