//  biblio.cpp: definiciones para el programa 20
//  Fecha: 2/12/2019; 7:47 am
//  Revisin: 12/10/2020; 8:40 am
//  S. Galliano.
#include "biblio.h"

//  busca una clave
bool buscaKey( Str clave, const Obra & obra ) {
    Obra::const_iterator i = obra.find( clave );
    return i not_eq obra.end();
}

//  busca un valor
bool buscaVal( Str valor, const Obra & obra ) {
    Obra::const_iterator i;
    Obra::const_iterator end( obra.end() );

    for ( i = obra.begin(); i not_eq end; ++i ) {
        if ( i->second == valor )
            return true;
    } // for

    return false;
}

#include <cstdlib>
#include <iostream>
using std::cout;
using std::cerr;
using std::cin;
using std::getline;
using std::make_pair;

// entra un ttulo - el nombre puede ser mltiple; el ttulo, no.
void entrar( Obra & obra ) {
    system( "cls" );
    cout << "Insertar unas obras. T para terminar.";
    Obra temp;         // una estructura temporal
    Str nombre, titulo; // variables
    int n = 0;

    do {
        cout << "\nApellido, inicial del nombre: ";
        getline( cin, nombre );

        if ( 'T' == toupper( nombre[0] ) and 1 == nombre.size() ) break;
        else {
            cout << "T\241tulo de su obra: ";
            getline( std::cin, titulo );

            if ( buscaVal( titulo, obra ) ) cout << ERR_E;
            else {
                obra.insert( make_pair( nombre, titulo ) );
                ++n;
            } // if-else
        } // if-else
    } while ( true ); // do-while

    n == 0
        ? cout << "Nada entr\242.\n\n"
        : n == 1
           ? cout << "Entr\242 una obra.\n\n"
           : cout << "Entraron " << n << " obras.\n\n";
}

#include <iomanip>
using std::setw;
using std::setfill;
using std::left;
using std::right;

// muestra todas las obras
void mostrar( const Obra & obra ) {
    cout << left << setfill( '.' ) << '\n';

    for ( auto x: obra )
        cout << setw( 20 ) << x.first << x.second << '\n';

    cout << right << setfill( ' ' ) << '\n';
}

// borra una obra
void borrarTit( Str titulo, Obra & obra ) {
    Obra::iterator i;
    Obra::iterator end( obra.end() );

    //  se va la obra con su nombre
    for ( i = obra.begin(); i not_eq end; ++i ) {
        if ( i->second == titulo ) {
            obra.erase( i );
            break;
        } // if
    } // for
}
