#ifndef BIBLIO_H_INCLUDED
#define BIBLIO_H_INCLUDED

//  biblio.h: definiciones para el programa 20
//  Fecha: 2/12/2019; 7:47 am
//  Revisin: 12/10/2020; 8:40 am
//  S. Galliano.

#include <string>
typedef std::string Str;

const Str ERR_V( "El listado est\240 vac\241o.\n\n" );
const Str ERR_E( "Est\240.\n\n" );
const Str ERR_N( "No est\240.\n\n" );
const Str HECHO( "Hecho.\n\n" );

#include <map>
typedef std::multimap<Str, Str> Obra;

//  busca una clave en la BD
bool buscaKey( Str clave, const Obra & obra );

//  busca un valor en la BD
bool buscaVal( Str valor, const Obra & obra );

// entra un ttulo - el autor puede ser mltiple; el ttulo, no.
void entrar( Obra & obra );

// muestra la obra de un nombre
void mostrar( Str clave, const Obra & obra );

// muestra todas las obras
void mostrar( const Obra & obra );

// edita una obra
//void editar( Str nombre, Str titulo, Obra & obra );

// borra una obra
void borrarTit( Str titulo, Obra & obra );

#endif // BIBLIO_H_INCLUDED
