// Programa 20: bibliografa
// Fecha: 2/12/2019; 7:47 am
// Revisin: 12/10/2020; 8:40 am
// S. Galliano.

#include "menu.h"
#include "biblio.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>

int main() {
    using std::cout;
    using std::cin;
    using std::cerr;
    Str info( "Ejercicio 20: manejo de una biblioteca.\n" );
    Obra obra;  // una bolsa
    int n;      // la cantidad de obras
    int opcion; // la opcin del men

    while ( true ) {
        opcion = menu( info );

        if ( Termina == opcion )
            return EXIT_SUCCESS;
        else
            n = obra.size();

        switch( opcion ) {
        case Ayuda:
            ayudar( info );
            break;
        case Inserta:
            entrar( obra );
            break;
        case BuscaA:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                Str nombre;
                cout << "\nApellido, inicial del nombre: ";
                std::getline( cin, nombre );
                buscaKey( nombre, obra ) ? cout << ERR_E : cerr << ERR_N;
            } // if-else
            break;
        case BuscaO:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                Str titulo;
                cout << "\nT\241tulo de la obra: ";
                std::getline( cin, titulo );
                buscaVal( titulo, obra ) ? cout << ERR_E : cerr << ERR_N;
            } // if-else
            break;
        case Muestra:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                cout << std::left << std::setw( 20 )
                << "Autor" << "T\241tulo" << std::right;
                mostrar( obra );
            } // if-else
            break;
        case EliminaO:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                Str titulo;
                cout << "\nT\241tulo de la obra: ";
                std::getline( cin, titulo );

                if ( buscaVal( titulo, obra ) ) {
                    borrarTit( titulo, obra );
                    cerr << HECHO;
                } else {
                    cout << ERR_N;
                } // if-else
            } // if-else
            break;
        case EliminaA:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                Str clave;
                cout << "\nApellido, inicial del nombre: ";
                std::getline( cin, clave );
                Obra::const_iterator i = obra.find( clave );

                if ( i == obra.end() ) {
                    cout << ERR_N;
                } else {
                    obra.erase( clave );
                    cerr << HECHO;
                } // if-else
            } // if-else
            break;
        case Cuenta:
            0 == n
                ? std::cerr << ERR_V
                : 1 == n
                    ? std::cout << "\nUna obra.\n\n"
                    : std::cout << '\n' << n << " obras.\n\n";
            break;
        case Vacia:
            if ( 0 == n ) std::cerr << ERR_V;
            else {
                char sn;
                cout << "Esta acci\242n es definitiva\n\250Procedo (s/n)? ";
                ( cin >> sn ).get(); // limpia el bfer

                if ( 'S' == toupper( sn ) ) {
                    obra.clear();
                    cerr << HECHO;
                } // if
            } // if-else
            break;
        } // switch

        system( "pause" );
    } // while
}
