//  paniol.cpp: definiciones para el problema 21
//  Fecha: 25/4/2020; 5:34 pm
//  Revisin: 14/9/2020; 5:30 am
//  Por: S. Galliano.
#include "paniol.h"

//  el paol fija su stock
Paniol::Paniol() {
    sierraK = std::make_tuple( "Sierra de calar", 6.80, 0 );
    sierraT = std::make_tuple( "Sierra de trocear", 8.99, 0 );
    atornil = std::make_tuple( "Atornillador", 3.55, 0 );
    lijadoP = std::make_tuple( "Lijadora plana", 11.22, 0 );
    costoTotal = 0;
}

#include <iostream>
using std::cout;
using std::cin;
#include <iomanip>
using std::setw;

void Paniol::tomarHerr( Data & herr ) {
    Str h;
    float p;
    int c;
    std::tie( h, p, c ) = herr;
    cout << setw( 18 ) << h << ", cantidad? ";
    cin >> c;
    costoTotal += c * p;
    herr = make_tuple( h, p, c );
}

void Paniol::tomarPedido() {
    tomarHerr( sierraK );
    tomarHerr( sierraT );
    tomarHerr( atornil );
    tomarHerr( lijadoP );
}

using std::getline;

void Paniol::tomarDocente() {
    Str profesor, fecha;
    cout << "Nombre completo del docente: ";
    getline( cin, profesor );
    cout << "Fecha del pedido (d\241a/mes/a\244o): ";
    getline( cin, fecha );
    profe = make_pair( profesor, fecha );
}

void Paniol::mostrarStock() {
    cout << std::fixed <<
         "Stock del pa\244ol:\n" << std::left << std::setprecision( 2 )
         << setw( 18 ) << "Herramienta" << std::right
         << setw( 8 ) << "Precio\n";

    mostrarHerr( sierraK, false );
    mostrarHerr( sierraT, false );
    mostrarHerr( atornil, false );
    mostrarHerr( lijadoP, false );

    cout << std::setfill( ' ' ) << std::setprecision( 0 ) << '\n';
}

void Paniol::mostrarHerr( Data & herr, bool largo ) const {
    Str h;
    float p;
    int c;
    std::tie( h, p, c ) = herr;
    if ( largo ) {
        cout << std::left << std::setfill( ' ' ) << std::setprecision( 2 )
             << setw( 18 )  << h << std::right   << setw( 8 ) << p
             << setw( 8 )  << c << setw( 12 ) << c * p;
    } else {
        cout << std::left << std::setfill( '.' ) << std::setprecision( 2 )
             << setw( 18 )  << h << std::right   << setw( 8 ) << p;
    } // if-else

    cout << std::setprecision( 0 ) << '\n';
}

void Paniol::mostrarModelo() {
    cout << std::left << "\nHoja de pedidos.\n"
         << profe.first  << " - Fecha: " << profe.second << '\n' << std::left
         << setw( 18 ) << "Herramienta" << std::right
         << setw( 8 ) << "Precio"
         << setw( 8 ) << "Cant"
         << setw( 12 ) << "Costo\n";

    mostrarHerr( sierraK );
    mostrarHerr( sierraT );
    mostrarHerr( atornil );
    mostrarHerr( lijadoP );

    cout << std::setfill( '.' ) << std::setprecision( 2 ) << std::left
         << setw ( 40 ) << "Costo total:" << costoTotal << "$\n\n";
}
