#ifndef PANIOL_H_INCLUDED
#define PANIOL_H_INCLUDED

//  nombre.h: definiciones para el problema 21
//  Fecha: 25/4/2020; 5:34 pm
//  Revisin: 14/9/2020; 5:30 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
#include <tuple>
typedef std::tuple<Str, float, int> Data;
typedef std::pair<Str, Str> Doc;

//  el paol puede ser considerado una estructura que lleva las
//  herramientas que controla y el docente que las solicita para
//  su clase; debe saber tomar las herramientas, el docente, calcular
//  el costo total de su pedido, su fecha y mostrar el modelo de
//  salida del paol.
struct Paniol {
    Paniol(); // constructor
    //  mtodos
    void tomarHerr( Data & herr );
    void mostrarHerr( Data & herr, bool largo = true ) const;
    void tomarDocente();
    void mostrarStock ();
    void tomarPedido  ();
    void mostrarModelo();
    //  miembros
    int cantidad;
    float costoTotal;
    Doc profe;
    Data sierraK;
    Data sierraT;
    Data atornil;
    Data lijadoP;
};

#endif // PANIOL_H_INCLUDED
