#ifndef CONVERSOR_H_INCLUDED
#define CONVERSOR_H_INCLUDED

//  conversor.h: definiciones para el programa 22
//  Fecha: 9/5/2020; 12 m
//  Revisin: 13/9/2020; 5:50 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
#include <tuple>
typedef std::tuple<Str, Str, Str, double> Dato;
typedef std::tuple<double, double, double, Str, Str> Info;
#include <vector>
typedef std::vector<Dato> Vct;
#include <fstream>

//  carga la base de datos c:/temp/BD/equivalencias.txt
//  input: un operador de flujo de lectura
//  output: el vector con las tradas
struct Cargador {
    Cargador(); // constructor
    // mtodos
    bool leerData( std::istream & leer, Vct & vect ); // carga la BD
    void convertir( double val ); // convierte un dato en informacin
    void imprimir();  // imprime la informacin
    //  miembros
    Str id;   // la base de datos
    Dato dat; // un dato
    Info inf; // una informacin
    Vct vct;  // vector que carga del archivo
};

#endif // CONVERSOR_H_INCLUDED
