//  grafica.cpp: definiciones para el programa 23
//  Fecha: 3/2/2020; 7 pm
//  Revisin: 13/9/2020; 6:12 am
//  Por: S. Galliano.
#include "grafica.h"

Nodo * cargar() {
    Nodo * temp = new Nodo;

    temp->insert( std::make_pair( 40.4, "Turba"         ) );
    temp->insert( std::make_pair( 22.5, "Gas natural"   ) );
    temp->insert( std::make_pair( 16.2, "Hidr\240ulica" ) );
    temp->insert( std::make_pair( 10.9, "Nuclear"       ) );
    temp->insert( std::make_pair(  5.0, "Petr\242leo"   ) );
    temp->insert( std::make_pair(  5.0, "Renovables"    ) );

    return temp;
}

#include <iostream>
using std::cout;
#include <iomanip>

void tabular( Nodo * nodo ) {
    //  Encabezamiento
    cout << "Tabla. Producci\242n 2012\n"
         << "-------------------------\n"
         << std::setprecision( 1 ) << std::fixed;

    for ( auto x: *nodo ) {
        std::cout << std::left <<
        std::setw( 12 ) << x.second << std::right <<
        std::setw( 8 )  << x.first  << '\n';
    } // for

    cout << "-------------------------\n\n";
}

//  dos funciones auxiliares para cargar el eje horizontal
void cargaEscala() {
    cout << std::setw( 14 ) << '|';

    for ( int i = 5; i <= 40; i += 5 ) {
        cout << std::setw( 5 ) << i;
    } // for

    cout << " %\n";
}

void cargaEje() {
    cout << std::setw( 14 );

    for ( int i = 0; i <= 40; ++i ) {
        0 == i % 5
        ? cout << '+'
               : cout << '-';
    } // for

    cout << "--\n";

}

void graficar( Nodo * nodo ) {
    cout << "Gr\240fica. Producci\242n 2012\n";
    cargaEscala();
    cargaEje();

    for ( auto x: *nodo ) {
        std::cout <<
        std::setw( 12 ) << x.second << " |" <<
        std::setw( x.first + 1 ) << std::setfill( '*' ) << '\n' <<
        std::setfill( ' ' );
    } // for

    cout << std::setw( 16 ) << "|\n\n";

}
