//  Problema 25: dulce
//  Fecha: 7/4/2020; 11 pm
//  Revisin: 15/10/2020; 7 pm
//  S. Galliano.

#include "menu.h"
#include "almacen.h"
#include <iostream>
#include <cstdlib>

// Str VACIA( "Error: la BD est\240 vac\241a.\n\n" );
// Str MA_NO( "Error: esa marca no est\240 en la BD.\n\n" );
// Str HECHO( "\n\255Hecho!\n\n" );

int main() {
    std::string info( "Ejercicio 25. Una base de datos.\n\n" );

    Almacen * pInv = new Almacen; // el inventario
    unsigned opcion;              // la opcin del men
    Str mk;                       // una marca
    int n, ct;                    // una cantidad
    double pr;                    // un precio

    while ( true ) {
        opcion = menu( info );

        if ( opcion == Terminar ) {
            delete pInv;
            return EXIT_SUCCESS;
        } else
			n = pInv->stock.size();

        switch ( opcion ) {
        case Ayudar:
            ayuda( info );
            break;
		case Mostrar:
            if ( pInv->stock.empty() ) {
                std::cerr << VACIA;
            } else {
                pInv->mostrarStock();
            } // if-else
            break;
        case Adicionar:
            std::cout << "   \250Marca? ";
            std::getline( std::cin, mk );
            std::cout << "\250Cantidad? ";
            std::cin >> ct;
            std::cout << "  \250Precio? ";
            std::cin >> pr;
            pInv->adicionar( mk, pr, ct );
            std::cout << HECHO;
            break;
		case EditarP:
            if ( pInv->stock.empty() ) {
                std::cerr << VACIA;
            } else {
                std::cout << "   \250Marca? ";
                std::getline( std::cin, mk );

                if ( pInv->marcaEnStock( mk ) ) {
                    std::cout << "  \250Precio? ";
                    std::cin >> pr;
                    pInv->editarPr( mk, pr );
                    std::cout << HECHO;
                } else {
                    std::cerr << MA_NO;
                } // if-else
            } // if-else
            break;
        case EditarC:
            if ( pInv->stock.empty() ) {
                std::cerr << VACIA;
            } else {
                std::cout << "   \250Marca? ";
                std::getline( std::cin, mk );

                if ( pInv->marcaEnStock( mk ) ) {
                    std::cout << "\250Cantidad? ";
                    std::cin >> ct;
                    pInv->editarCt( mk, ct );
                    std::cout << HECHO;
                } else {
                    std::cerr << MA_NO;
                } // if-else
            } // if-else
            break;
		case Borrar:
            if ( 0 == n ) {
                std::cerr << VACIA;
            } else {
                std::cout << "\250Marca a borrar? >";
                std::cin >> mk;

                if ( pInv->marcaEnStock( mk ) ) {
                    pInv->eliminarSnack( mk );
                    std::cout << HECHO;
                } else {
                    std::cerr << MA_NO;
                } // if-else
            } // if-else
            break;
        case Vaciar:
            if ( 0 == n ) {
                std::cerr << VACIA;
            } else {
                char sn;
                std::cout << "\250Vaciar el inventario? (s/n) >";
                std::cin >> sn;

                if ( 'S' == toupper( sn ) ) {
                    pInv->stock.clear();
                    std::cout << HECHO;
                } // if
            } // if-else
            break;
        } // switch

        system( "pause" );
    } // while
}
