//  obras.cpp: definiciones para el problema 26
//  Fecha: 10/4/2020; 10:13 pm
//  Revisin: 11/10/2020; 9:50 am
//  Por: S. Galliano.
#include "biblio.h"

//  funcin de ordenamiento fuerte, de menor a mayor
//  hay que bajar dos niveles de indireccin
bool menorQue( const Obra & d1, const Obra & d2 ) {
    Str p1( d1.dato.first ), p2( d1.dato.second ),
        q1( d2.dato.first ), q2( d2.dato.second );

    if ( p1 < q1 ) return true;
    if ( p1 == q1 and p2 < q2 ) return true;
    return false;
}

// el mdulo que trabaja con for_each()
void mostrar( const Obra & obra ) { obra.mostrarObra(); }

#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <ios>
using std::cout;
using std::cerr;

//  las obras
bool Obra::autorEsta( Str nom ) const { return nom == dato.first;  }
bool Obra::obraEsta( Str tit )  const { return tit == dato.second; }
void Obra::entrarObra( Str nom, Str tit ) { dato = std::make_pair( nom, tit ); }
void Obra::mostrarObra() const {
    std::ios::fmtflags oldFlags = cout.flags();
    cout << std::left << std::setfill( '.' );
    cout << std::setw( 20 ) << dato.first << dato.second;
    cout << std::right << std::setfill( ' ' ) << '\n';
    cout.flags( oldFlags );
}

//  el mdulo que trabaja con el nodo
void entrarObras( Nodo * nodo ) {
    system( "cls" );
    cout << "Insertar unas obras. T para terminar.";
    Obra tmp;           // una estructura temporal
    Str nombre, titulo; // variables
    int n = 0;

    do {
        cout << "\nApellido, inicial del nombre del autor: ";
        getline( std::cin, nombre );

        if ( "" == nombre ) continue;
        else if ( 'T' == toupper( nombre[0] ) and 1 == nombre.size() ) break;
        else {
            cout << "T\241tulo de su obra: ";
            getline( std::cin, titulo );

            if ( tmp.autorEsta( nombre ) and tmp.obraEsta( titulo ) ) {
                cerr << ERR_E;
            } else {
                tmp.entrarObra( nombre, titulo );
                nodo->push_back( tmp );
                ++n;
            } // if-else
        } // if-else
    } while ( true ); // do-while

    n == 0
        ? cout << "Nada entr\242.\n\n"
        : n == 1
           ? cout << "Entr\242 una obra.\n\n"
           : cout << "Entraron " << n << " obras.\n\n";
}

