#ifndef BIBLIO_H_INCLUDED
#define BIBLIO_H_INCLUDED

//  obras.h: declaraciones para el problema 26
//  Fecha: 10/4/2020; 10:13 pm
//  Revisin: 11/10/2020; 9:50 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;

const Str ERR_V( "El listado est\240 vac\241o.\n\n" );
const Str ERR_E( "Est\240.\n\n" );
const Str ERR_N( "No est\240.\n\n" );
const Str HECHO( "Hecho.\n\n" );

typedef std::pair<Str, Str> Data;

struct Obra {
    void entrarObra( Str nom, Str tit );
    void mostrarObra() const;
    bool obraEsta( Str tit )  const;
    bool autorEsta( Str nom ) const;
    // miembro
    Data dato;
};

#include <list>
typedef std::list<Obra> Nodo;

//  este es el mdulo que trabaja con el nodo
void entrarObras( Nodo * nodo );

//  este es el mdulo que trabaja con for_each()
void mostrar( const Obra & obra );

//  funcin de ordenamiento fuerte, de menor a mayor
bool menorQue( const Obra & d1, const Obra & d2 );

#endif // BIBLIO_H_INCLUDED
