//  Problema 26: bibliografa
//  Fecha: 10/4/2020; 10:13 pm
//  Revisin: 11/10/2020; 9:50 am
//  S. Galliano.

#include "biblio.h"
#include "menu.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <algorithm>

int main() {
    using std::cout;
    using std::cin;
    using std::cerr;
    using std::getline;

    Nodo *nodo = new Nodo;             // listado de obras

    Obra clave;    // una obra en la lista
    short opcion;  // opcin del menu
    Str valor;     // un valor o un ttulo
    bool resp;     // una respuesta
    unsigned cant; // la cantidad de nodos;
    Str info( "Ejercicio 26: manejo de una biblioteca.\n\n" );

    while ( true ) {
        opcion = menu( info );

        if ( Termina == opcion ) {
            delete nodo;
            return EXIT_SUCCESS;
        } else
            cant = nodo->size();

        switch ( opcion ) {
        case Ayuda:
            ayudar( info );
            break;
        case Inserta:
            entrarObras( nodo );
            break;
        case Cuenta:
            0 == cant
                ? cerr << ERR_V
                : 1 == cant
                    ? cout << "Hay una obra.\n\n"
                    : cout << "Hay " << cant << " obras.\n\n";
            break;
        case Muestra:
            if ( 0 == cant )
                cerr << ERR_V;
            else {
                nodo->sort( menorQue );
                cout << std::left << std::setw( 20 )
                << "Autor" << "T\241tulo\n" << std::right;
                for_each( nodo->begin(), nodo->end(), mostrar );
                cout << '\n';
            } // if-else
            break;
        case EliminaA:
            if ( 0 == cant )
                cerr << ERR_V;
            else {
                cout << "\nApellido, inicial del nombre del autor: ";
                getline( std::cin, valor );
                Nodo::iterator i = nodo->begin();

                for ( auto x: *nodo ) {
                    if ( x.autorEsta( valor ) ) {
                        nodo->erase( i );
                    } // if

                    ++i;
                } // for-en-rangos

                cout << HECHO;
            } // if-else
            break;
        case EliminaO:
            if ( 0 == cant )
                cerr << ERR_V;
            else {
                cout << "T\241tulo de la obra: ";;
                getline( cin, valor );
                Nodo::iterator i = nodo->begin();

                for ( auto x: *nodo ) {
                    if ( x.obraEsta( valor ) ) {
                        nodo->erase( i );
                        cout << HECHO;
                        break;
                    } // if

                    ++i;
                } // for-en-rangos
            } // if-else
            break;
        case BuscaA:
            cout << "\nApellido, inicial del nombre del autor: ";
            getline( cin, valor );
            resp = false;

            for ( auto x: *nodo ) {
                if ( x.autorEsta( valor ) ) {
                    resp = true;
                    break;
                };
            }

            resp ? cout << ERR_E : cerr << ERR_N;
            break;
        case BuscaO:
            cout << "T\241tulo completo: ";
            getline( cin, valor );
            resp = false;

            for ( auto x: *nodo ) {
                if ( x.obraEsta( valor ) ) {
                    resp = true;
                    break;
                };
            }

            resp ? cout << ERR_E : cerr << ERR_N;
            break;
        case Vacia:
            if ( 0 == cant )
                cerr << ERR_V;
            else {
                char sn;
                cout << "Esta acci\242n es definitiva\nProcedo \250(s/n)? ";
                ( cin >> sn ).get(); // limpia el bfer

                if ( 'S' == toupper( sn ) ) {
                    nodo->clear();
                    cerr << HECHO;
                } // if
            }
        } // switch

        system( "pause" );
    } // while
}
