//  muestra.cpp: definiciones para el problema 29
//  Fecha: 1/6/2020; 2:20 pm
//  Revisin: 13/9/2020; 5:02 pm
//  Por: S. Galliano.
#include "../../Programas/deposito/rnd.h"
#include "muestra.h"
#include <ctime>
#include <iostream>

//  genera un punto de entrada al archivo de valores
long generaEntrada() {
    long Max = POBLACN - MUESTRA;

    // generador Mersenne Twister de nmeros aleatorios
    // con una semilla derivada de rand()
    std::mt19937 mt( rand() );

    // crea una distribucin uniforme de enteros
    // Dado un generador de nmeros, producir
    // uno en el rango (0:Max)
    std::uniform_int_distribution<int>dist( 0, Max );

    // un nmero al azar a partir del valor
    // mximo que puede alcanzar una muestra
    long num;

    while ( true ) {
        num = dist( mt );
        if ( num < Max ) return num;
    } // while
}

#include "estads.h"
#include <iostream>
#include <fstream>
#include <cstdlib>

//  genera los valores y los pone en el archivo
Vct generaPoblacion() {
    srand( time( 0 ) );
    Vct vct( POBLACN ); // un vector
    GAUSS( vct );     // relleno de valores...
    std::ofstream Escribe( "c:/temp/poblacion.txt" );

    if ( Escribe.fail() ) {
        std::cerr << "No pude escribir. Abortando.\n\n";
       exit( EXIT_FAILURE );
    } else {
        for ( auto x: vct ) {
            Escribe << x << '\n';
        } // for
    } // if-else

    return vct;
}

#include <iomanip>
using std::setw;

//  imprime los estadsticos
void imprimeVals( Vals & valores ) {
    double Media, Desv, Medn, Rang;
    std::tie( Media, Desv, Medn, Rang ) = valores;

    std::cout  << std::fixed << std::setprecision( 4 ) << std::showpos <<
    setw( 13 ) << "Media = "      << Media << '\n' <<
    setw( 13 ) << "Mediana = "    << Medn  << '\n' <<
    setw( 13 ) << "Desviacion = " << Desv  << '\n' <<
    setw( 13 ) << "Rango = "      << Rang  << "\n\n";
}

#include <fstream>
#include <cstdio>
#include <string>

//  genera una muestra
Vals generaMuestra() {
    //  valores ledos desde el archivo
    // aqu hace falta cdigo defensivo, porque
    // si el fichero no est, no puede abrirlo
    std::ifstream Leyendo( "c:/temp/poblacion.txt" );
    Stat * St = new Stat;
    double val;
    Vals resp;
    St->vct.clear();

    if ( Leyendo.fail() ) {
        std::cerr << "No pude leer. Abortando.\n\n";
        exit( EXIT_FAILURE );
    } else {
        long punto = generaEntrada();

        for ( long i = 0; i < punto; ++i ) {
            Leyendo >> val;
        }

        for ( long i = 0; i < MUESTRA / 2; ++i ) {
            Leyendo >> val;
            St->vct.push_back( val );
        } // for

        double Max   = *max_element( St->vct.begin(), St->vct.end() );
        double Min   = *min_element( St->vct.begin(), St->vct.end() );
        double Rang  = Max - Min;

        sort( St->vct.begin(), St->vct.end() );

        double Media = St->promedio();
        double Desv  = St->desviac();
        double Medn  = St->mediana();
        resp = std::make_tuple( Media, Desv, Medn, Rang );
    } // if-else

    delete St;
    return resp;
}
