/*
    Programa 1: un driver para probar las plantillas.
    Fecha: 21/8/2019; 4:32 pm
    Revisin: 18/3/2020; 8:02 am
    S. Galliano.
*/

#include "../deposito/print.h"
#include "../deposito/rnd.h"
#include "../deposito/varray.h"
#include <vector>
#include <list>
#include <deque>

typedef std::vector<int> Ary;
using namespace std;


int main() {
    srand( time( nullptr ) );
    cout << "Programa 1: trabajando con plantillas.\n";
    vector<int> vInt( 6 );
    RELLENA_I( vInt, 10, 40 );
    LISTA( vInt, "\nVector de 6 valores entre 10 y 40\n[" );
    cout << "\b]\n";

    // listas: 6 valores enteros entre 20 y 30
    list<int>aLst( 6 );
    RELLENA_I( aLst, 10, 40 );
    LISTA( aLst, "\nLista de 6 valores enteros entre 10 y 40:\n<" );
    cout << "\b>\n";
    MUESTRA( aLst, "\nMuestra los mismos valores que el vector:\n" );
    cout << '\n';

    //  colas: 6 valores reales entre 10 y 40
    deque<double>aDek( 6 );
    RELLENA_R( aDek, 10, 40 );
    LISTA( aDek, "\nCola de 6 valores reales entre 10 y 40, con 3 dec.:\n<", 3 );
    cout << "\b>\n";

    // vectores: 30 valores gaussianos
    vector<double>vct( 36 );
    GAUSS( vct );
    TABULA( vct, "\nTabla a 6 cols de 36 valores normalizados, con 2 dec.:\n", 2, true, 6 );

    //  valarrays: 6 valores reales entre 20 y 30
    valarray<double>va( 6 );
    RELLENA_VD( va, 6, 20, 30 );
    cout << "Un valarray en memoria, de 6 valores reales.\n";
    cout << "Impreso como un vector-fila, 5 dec.:\n";
    cout << std::setprecision( 5 );
    PRINTVA( va, 6 );
    cout << "\n\nAhora impreso como un vector-columna, 4 dec.:\n";
    cout << std::setprecision( 4 );
    PRINTVA( va, 1 );
    cout << "\nAhora impreso como tabla de 3x2, 3 dec.:\n";
    cout << std::setprecision( 3 );
    PRINTVA( va, 2 );
    cout << "\nAhora impreso como tabla de 2x3, 2 dec.:\n";
    cout << std::setprecision( 2 );
    PRINTVA( va, 3 );
    cout << "\nAhora mostrando el slice(1,2,3), 1 dec.:\n";
    cout << std::setprecision( 1 );
    PRINTVA( VA( va[slice( 1, 2, 3 )] ) );
    cout << '\n';

    system( "pause" );
    return EXIT_SUCCESS;
}
