//  vectores.cpp: definiciones para el programa 5
//  Fecha: 12/4/2020; 1 pm
//  Por: S. Galliano.
#include "vectores.h"
#include <iostream>
#include <ios>
using std::cout;
using std::cin;

void Vector::entrar( Str id ) {
    cout << "Vector " << id << " en formato (x, y): ";
    double a, b;
    char parentesis, coma;
    std::ios::fmtflags oldFlags = cout.flags();
    cin.setf( std::ios::skipws );   // evita los espacios en blanco
    cin >> parentesis;              // el parntesis
    cin >> a;                       // la 1ra coordenada
    cin >> coma;                    // la coma
    cin >> b;                       // la 2da coordenada
    cin.ignore( 255, '\n' );        // deja limpio el bfer
    cout.flags( oldFlags );
    vect.clear();        // vaca el vector por si acaso...
    vect.push_back( a ); // entra la 1ra. coordenada
    vect.push_back( b ); // entra la 2da. coordenada
}

#include "../deposito/print.h"

void Vector::mostrar( Str id ) {
    LISTA( vect, "Vector " + id + " (", 2 );
    cout << "\b)\n";
}

#include <numeric>

double Vector::pPunto( Vector B ) {
    return inner_product( vect.begin(), vect.end(), B.vect.begin(), 0.0 );
}

#include <algorithm>
#include <cmath>

//  la norma del vector; los clculos son sobre uno temporal;
//  la elevacin al cuadrado se hace multiplicando el valor por si mismo
double Vector::norma() {
    Vct tmp( vect ); // se traslada el vector
    transform(
        tmp.begin(), tmp.end(),   // rango de la fuente: toda
        tmp.begin(),              // por dnde inicia el destino
        tmp.begin(),              // a partir de aqu entran los valores
        std::multiplies<double>() // operacin de elevacin al cuadrado
    );
    return sqrt( accumulate( tmp.begin(), tmp.end(), 0.0 ) );
}
