//  ops_es.cpp: definiciones para el programa 6
//  Fecha: 4/11/2019; 1:20 pm
//  Revisin: 8/9/2020; 12:28 pm
//  S. Galliano.

#include "ops_es.h"
#include <iostream>
#include <iomanip>

// pone una lnea doble por omisin, o simple, de tamao n en consola
void ponerLinea( int n, bool doble ) {
    doble ? std::cout << std::setfill( '=' ) : std::cout << std::setfill( '-' );
    std::cout << std::setw( n ) << '\n' << std::setfill( ' ' );
}

#include <cstring>
#include <fstream>

//  nombre de las materias, ledos desde el archivo archy
Vct cargarMaterias( Str archy ) {
    std::ifstream Leyendo( archy );
    if( not Leyendo.is_open() ) throw ERR;  // no abri? lanza la excepcin

    Vct vc;           // <-- vector de cadenas
    Str recd;         // record del archivo
    char delim = ','; // delimitador CSV de cada campo

    while( Leyendo.good() ) {
        std::getline( Leyendo, recd, delim );
        vc.push_back( recd ); // <-- vector de cadenas
    } // while

    return vc; // <-- vector de cadenas
}

//  valores de las notas ledos desde el archivo
Val cargarNotas( Str archy, int n ) {
    std::ifstream Leyendo( archy );
    if( not Leyendo.is_open() ) throw ERR;  // no abri? lanza la excepcin

    Val vAry( n );    // <-- valarray de dobles
    Str recd;         // record del archivo
    char delim = ','; // delimitador CSV de cada campo
    int i = 0;        // <-- ndice del arreglo

    while( Leyendo.good() ) {
        std::getline( Leyendo, recd, delim );
        vAry[i] = atof( recd.c_str() ); // <-- valarray de dobles
        ++i;
    } // while

    return vAry; // <-- valarray de dobles
}

//  pone los promedios por asignatura en consola
Val tabular( const Val & prom, int filas, int cols ) {
    Val tbl( cols ); // el valarray de promedios

    for( int i = 0; i < cols; ++i ) {
        for( int j = 0; j < filas; j++ )
            tbl[i] += prom[i + j * cols];

        tbl[i] /= filas;
    } // for

    return tbl;
}
