// Programa 10: conjuntos
// Fecha: 22/8/2019; 3:30 pm
// Revisin: 24/2/2020; 1:20 pm
// S. Galliano.

#include "../deposito/print.h"
#include "../deposito/rnd.h"
#include <iostream>
#include <cstdlib>
#include <string>
#include <set>

//typedef std::string Str;
//typedef std::multiset<Str> mmSet;

const int LIM_SUP = 50; // nmero mayor
const int LIM_INF = 1;  // nmero menor
const int TOP_LIM = 10; // set mayor
typedef std::multiset<int> mmSet;

int main() {
    using std::cout;
    cout << "Programa 10: \240lgebra de conjuntos\n\n";
    srand( time( nullptr ) );           // una semilla aleatoria
    std::array<int, TOP_LIM>aryA, aryB; // un arreglo auxiliar
    mmSet C;                            // la bolsa
    std::insert_iterator<mmSet>insertar( C, C.begin() ); // el insertor

    //  los conjuntos
/*
    mmSet A;
    A.insert("Platon");
    A.insert("Arquimedes");
    A.insert("Zorba");
    A.insert("Pitagoras");
    LISTA(A, "Conjunto A { "); cout << "}\n";

    mmSet B;
    B.insert("Manuel");
    B.insert("Zorba");
    B.insert("Leonela");
    LISTA(B, "Conjunto B { "); cout << "}\n\n";
*/
    RELLENA_I( aryA, LIM_INF, LIM_SUP );
    RELLENA_I( aryB, LIM_INF, LIM_SUP );
    std::set<int> A( begin( aryA ), end( aryA ) );
    std::set<int> B( begin( aryB ), end( aryB ) - 6 );
    LISTA( A, "Conjunto A { " ); cout << "}\n";
    LISTA( B, "Conjunto B { " ); cout << "}\n\n";

    //  las respuestas:
    //  mezcla
    merge(A.begin(), A.end(), B.begin(), B.end(), insertar);
    LISTA(C, "\tMezcla  { "); cout << "}\n";
    //  unin
    C.clear();
    set_union(A.begin(), A.end(), B.begin(), B.end(), insertar);
    LISTA(C, "\t Uni\242n  { "); cout << "}\n";
    //  interseccin y pertenencia de B respecto a A
    C.clear();
    set_intersection(A.begin(), A.end(), B.begin(), B.end(), insertar);

    if ( C.empty() ) {
        cout << "  Intersecci\242n  Conjunto vac\241o.\n";
        cout << "  Pertenencia\tB no es subconjunto de A\n";
    } else {
        LISTA(C, "  Intersecci\242n  { "); cout << "}\n";
        includes(A.begin(), A.end(), B.begin(), B.end())
            ? cout << "   Pertenencia\tB es subconjunto propio de A\n"
            : cout << "   Pertenencia\tB es subconjunto de A\n";
    }

    //  igualdad
    A == B
        ? cout << "      Igualdad\tSon iguales\n."
        : cout << "      Igualdad\tNo son iguales.\n";

    //  diferencia A\B
    C.clear();
    set_difference(A.begin(), A.end(), B.begin(), B.end(), insertar);

    if ( 0 == C.size() )
        cout << "Diferencia A\\B: conjunto vac\241o.\n";
    else {
        LISTA(C, "Diferencia A\\B  { ");
        cout << "}\n";
    }

    //  diferencia B\A
    C.clear();
    set_difference(B.begin(), B.end(), A.begin(), A.end(), insertar);

    if ( 0 == C.size() )
        cout << "Diferencia B\\A: conjunto vac\241o.\n";
    else {
        LISTA(C, "Diferencia B\\A  { ");
        cout << "}\n";
    }

    //  diferencia simtrica
    C.clear();
    set_symmetric_difference(A.begin(), A.end(), B.begin(), B.end(), insertar);

    if ( 0 == C.size() )
        cout << "Dif. sim\202trica: conjunto vac\241o.\n";
    else {
        LISTA(C, "Dif. sim\202trica  { ");
        cout << "}\n\n";
    }

    // fin
    system("pause");
    return EXIT_SUCCESS;
}
