// Programa 11: uso de la clase <std::complex>
#include <iostream>
#include <cstdlib>
#include <complex>
#include <iomanip>
#include <cmath>
#include <ios>

// Escribe un nmero complejo en formato z = a+/-bi
// input: un nmero complejo
// output: salida formateada a consola
void fmtSuma( std::string ID, const std::complex<float> & z );

// Escribe un nmero complejo en formato (M,A)
// M: mdulo del complejo; A: angulo de frase en grados
// input: un nmero complejo
// output: salida formateada a consola
void fmtPolar( std::string ID, const std::complex<float> & z );

int main() {
    using std::cout;
    using std::polar;
    cout << "Programa 11: aritm\240tica compleja.\n\n";
    // los nmeros
    std::complex<float> z1, z2;
    float esc;

    // entrada
    cout << "Entrar datos en formato (a,b):\n";
    cout << "Complejo z1 = ";
    std::cin >> z1;
    cout << "Complejo z2 = ";
    std::cin >> z2;
    cout << "Escalar: ";
    std::cin >> esc;

    // coordenadas
    cout << "\nEn formato z = a+bi\n";
    fmtSuma( "z1 = ", z1 );
    fmtSuma( "z2 = ", z2 );
    cout << "\nEn formato z = (Mod,Grad)\n";
    fmtPolar( "z1 = ", z1 );
    fmtPolar( "z2 = ", z2 );

    // formato general
    cout << std::setprecision( 2 ) << std::fixed;

    // conjugados
    cout << "\nConjugados:";
    cout << "\n~z1 = " << conj( z1 );
    cout << "\n~z2 = " << conj( z2 );

    // igualdad
    cout << "\n\nIgualdad:\n";
    z1 == z2
    ? cout << "z1 y z2 son iguales.\n"
           : cout << "z1 y z2 no son iguales.\n";

    // algunas operaciones aritmticas
    cout << "\nOperaciones aritm\202ticas:\n";
    cout << "(z1+z2) = " << z1 + z2 << '\n';
    cout << "(z1-z2) = " << z1 - z2 << '\n';
    cout << "(z1*z2) = " << z1 * z2 << '\n';
    cout << "(z1/z2) = " << z1 / z2 << '\n';

// con escalares
    cout << "\nOperaciones con escalares:\n";
    cout << "e+z1 = " << esc + z1 << '\n';
    cout << "e-z1 = " << esc - z1 << '\n';
    cout << "z1-e = " << z1 - esc << '\n';
    cout << "e*z1 = " << esc * z1 << '\n';
    cout << "z1*e = " << z1 * esc << '\n';
    cout << "z1/e = " << z1 / esc << '\n';
    cout << "e/z1 = " << esc / z1 << '\n';

    // aplicacin de funciones
    cout << "\nOperaci\242n con tres funciones:";
    cout << "\nCuadrado: z1" << pow( z1, 2.0 );
    cout << "\nRa\241z: z1" << sqrt( z1 );
    cout << "\nSeno: z1" << sin( z1 );
    cout << "\n\n";

    // fin
    system( "pause" );
    return EXIT_SUCCESS;
}

// muestra un nmero complejo en formato suma
void fmtSuma( std::string id, const std::complex<float> & z ) {
    using std::cout;
    std::ios::fmtflags oldFlags = cout.flags();
    cout << id << std::setprecision( 2 )
         << std::fixed << z.real()
         << std::showpos << z.imag() << "i\n";
    cout.flags( oldFlags );
}

// muestra un nmero complejo en formato polar
void fmtPolar( std::string id, const std::complex<float> & z ) {
    const double RAD2GRAD = 45.0 / atan( 1.0 );
    using std::cout;
    double sita = arg( z ) * RAD2GRAD;
    std::ios::fmtflags oldFlags = cout.flags();
    cout << id << std::setprecision( 2 )
         << std::fixed << "(" << abs( z )
         << "," << sita << ")\n";
    cout.flags( oldFlags );
}
