// Programa 16: leyendo desde un archivo
// Fecha: 26/8/2019; 7:52 am
// Revisin: 13/10/2020; 8:07 pm
// S. Galliano.

#include "entrada.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>

int main() {
    using std::cout;
    cout << "Programa 16: lee los n\243meros de un archivo\n"
            "y calcula sus principales estad\241sticos\n\n";
    Estads est; // los estadsticos
    Str archy;  // nombre de los archivos de lectura y escritura
    cout << "Nombre del archivo a leer: ";
    std::cin >> archy;

    //  cdigo defensivo aqu
    try {
        cout << "Leyendo del archivo " << archy;
        est.leerArchivo( archy );
        cout << "...hecho.\n\n";
    } catch( Str ) {
        std::cerr << ERROR;
        return EXIT_FAILURE;
    } // try-catch

    //  respuestas a consola
    cout << "Estad\241sticos a consola:\n\n";
    muestra( cout, "Media = ",     est.promedio() );
    muestra( cout, "Mediana = ",   est.mediana()  );
    muestra( cout, "Moda = ",      est.moda()     );
    muestra( cout, "Varianza = ",  est.varianza() );
    muestra( cout, "Desviac. = ",  sqrt( est.varianza() ) );
    muestra( cout, "M\240ximo = ", est.miMax()    );
    muestra( cout, "M\241nimo = ", est.miMin()    );
    muestra( cout, "Rango = ",     est.miMax() - est.miMin() );
    muestra( cout, "Suma = ",      est.suma()     );
    muestra( cout, "Cuenta = ",    est.vec.size() );
    cout << "\n";

    //  respuestas al disco
    cout << "Nombre del archivo a escribir: ";
    std::cin >> archy;

    // un flujo de salida
    std::ofstream Escribiendo;
    Escribiendo.open( archy );

    if ( Escribiendo.is_open() ) {
        cout << "Escribiendo al archivo " << archy;
        muestra( Escribiendo, "Media = ",     est.promedio() );
        muestra( Escribiendo, "Mediana = ",   est.mediana()  );
        muestra( Escribiendo, "Moda = ",      est.moda()     );
        muestra( Escribiendo, "Varianza = ",  est.varianza() );
        muestra( Escribiendo, "Desviac. = ",  sqrt( est.varianza() ) );
        muestra( Escribiendo, "M\240ximo = ", est.miMax()    );
        muestra( Escribiendo, "M\241nimo = ", est.miMin()    );
        muestra( Escribiendo, "Rango = ",     est.miMax() - est.miMin() );
        muestra( Escribiendo, "Suma = ",      est.suma()     );
        muestra( Escribiendo, "Cuenta = ",    est.vec.size() );
        cout << "...hecho.\n\n";
    } else {
        std::cerr << ERROR;
        return EXIT_FAILURE;
    } // if-else

    system( "pause" );
    return EXIT_SUCCESS;
}
