// conversor.cpp: definiciones para el programa 17
// Fecha: 26/8/2019; 9 am
// Revisin: 11/9/2020; 6:44 pm
// Por S. Galliano.
#include "conversor.h"

const int ANCHO = 5; // ancho del campo de salida

// convierte los mg/dl en mmol/l; frmula de Wikpedia
double inline convierte( int valor ) { return ( valor - 3.75 ) / 17.5; }

#include <ctime>

Lector::Lector() {
    archy = "C:/temp/glucosa.txt";
    time_t laFecha;            // variable para la fecha
    time( &laFecha );          // obteniendo la fecha actual
    fecha = ctime( &laFecha ); // preservando la fecha
    vct.clear();
}

#include <iostream>
#include <cassert>
using std::cout;

Par Lector::tomarLectura() {
    int mg; // mg/dl
    cout << "Programa 17: GLUC\340METRO conversor de lecturas.\n\n"
    "Lectura (mg/dl > 56): ";
    ( std::cin >> mg ).get();
    assert( mg > 56 );
    float mmol = convierte( mg ); // mmol/l
    return std::make_pair( mg, mmol );
}

#include <iomanip>

void Lector::mostrarInfo( std::ostream & escribir, Par dat ) {
    if ( escribir.fail() ) throw ERR_E;
    escribir << std::setw( ANCHO ) << dat.first << " mg/dl equivalen a "
             << std::fixed << std::right << std::setprecision( 1 )
             << std::setw( ANCHO - 1 ) << dat.second << " mmol/l; " << fecha;
}

// por simplicidad hace dos cosas: toma los
// datos del historial y los pone en consola
void Lector::leerData( std::istream & leer ) {
    if ( leer.fail() ) throw ERR_L;
    Str linea;

    while ( getline( leer, linea ) )
        vct.push_back( linea );

    cout << "\nHistorial:\n";

    for ( auto x: vct )
        cout << x << '\n';

    cout << '\n';
}
