//  cola.cpp: definiciones para el programa 18
//  Fecha: 19/4/2020; 12 m
//  Revisin: 12/9/2020; 9:42 am
//  Por: S. Galliano.
#include "cola.h"

//  funcin de ordenamiento fuerte
bool menor( const Nodo & n1, const Nodo & n2 ) {
    if ( n1.apellido < n2.apellido ) return true;
    if ( n1.apellido == n2.apellido and n1.nombre < n2.nombre ) return true;
    return false;
}

#include <iostream>
//  entra un nodo nuevo
void Nodo::entrar( bool dato ) {
    std::cout << "\nEntre un nombre: ";
    std::getline( std::cin, nombre );
    std::cout << "Ahora su apellido: ";
    std::getline( std::cin, apellido );

    if ( true == dato ) {
        std::cout << "Su entero asociado = ";
        ( std::cin >> valor ).get();
    }
}

#include <iomanip>
//  muestra un nodo en consola
void Nodo::mostrar() const {
    std::cout << std::left      <<
    std::setw( 16 ) << apellido <<
    std::setw( 16 ) << nombre   << std::right <<
    std::setw(  4 ) << valor    << '\n';
}

//  localiza el ndice del dato en la lista
int buscar( const Lst * lista, const Nodo & dato ) {
    int i = 0;

    for ( auto x: *lista ) {
        if ( x.nombre   == dato.nombre and
             x.apellido == dato.apellido ) {
            return i;
        } // if

        ++i;
    } // for

    return -1;
}

//  elimina el dato que est en la posicin pos
void borrar( Lst * lista, int pos ) {
    Lst::const_iterator i = lista->begin();
    advance( i, pos ); // avanza el ndice
    lista->erase( i );
}
