#ifndef COLA_H_INCLUDED
#define COLA_H_INCLUDED

//  cola.h: definiciones para el programa 18
//  Fecha: 19/4/2020; 12 m
//  Revisin: 1/10/2020; 7:40 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;

//  tipifica las respuestas
const Str ERR_N( "El nodo no est\240.\n\n" );
const Str ERR_Y( "El nodo ya est\240.\n\n" );
const Str ERR_V( "La lista est\240 vac\241a.\n\n" );
const Str HECHO( "Hecho.\n\n" );

//  un nodo de la lista
struct Nodo {
    // 	interfaz
    void mostrar() const;            // se muestra
    void entrar( bool dato = true ); // recibe/busca un nodo
    //  miembros:
    Str nombre;
    Str apellido;
    int valor;
};

#include <list>
typedef std::list<Nodo> Lst; // un listado de nodos

//  operador menor-que: funcin de ordenamiento
//  fuerte (lexicogrfico)
bool menor( const Nodo & n1, const Nodo & n2 );

//  localiza el ndice del dato en la lista
int buscar( const Lst * lista, const Nodo & dato );

//  elimina el dato que est en la posicin pos
void borrar( Lst * lista, int pos );

#endif // COLA_H_INCLUDED
