// Programa 18: colecciones complejas
// Fecha: 19/4/2020; 12 m
// Revisin: 12/9/2020; 9:42 am
// S. Galliano.

#include "menu.h"
#include "cola.h"
#include <iostream>
#include <algorithm>

int main() {
    using std::cout;
    using std::cin;
    using std::cerr;
    Str info( "Problema 18: manejando una secuencia ordenada\n" );
    Lst *pLst = new Lst; // una coleccin de datos
    Nodo dato;           // su estructura
    short opcion;        // la opcin del men
    int n;               // utilitario

    while ( true ) {
        opcion = menu( info );

        if ( Terminar == opcion ) {
            pLst->clear();
            delete pLst;
            return EXIT_SUCCESS;
        }

        switch ( opcion ) {
        case Insertar:
            dato.entrar();

            if ( -1 == buscar( pLst, dato ) ) { // busca por duplicados
                pLst->push_back( dato );        // si no est la cola lo aade...
                cout << HECHO;                  // ...y avisa...
            } else {
                cerr << ERR_Y; // otros, avisa que ya est
            }
            break;
        case Enumerar:
            n = pLst->size();

            if ( 0 == n )
                cerr << ERR_V;
            else
                1 == n
                    ? cout << "\nHay un nodo en la lista.\n\n"
                    : cout << "\nHay " << n << " nodos en la lista.\n\n";
            break;
        case Imprimir:
            if ( pLst->empty() )
                cerr << ERR_V;
            else {
                pLst->sort( menor );
                cout << '\n';

                for ( auto x: *pLst )
                    x.mostrar();

                cout << '\n';
            }
            break;
        case Buscar:
            if ( pLst->empty() )
                cerr << ERR_V;
            else {
                dato.entrar( false );
                 -1 == buscar( pLst, dato ) ? cerr << ERR_N : cerr << ERR_Y;
            }
            break;
        case Eliminar:
            if ( pLst->empty() ) {
                cerr << ERR_V;
                break;
            }

            dato.entrar( false );
            n = buscar( pLst, dato );

            if ( -1 == n )
                cerr << ERR_N;
            else {
                borrar( pLst, n );
                cout << HECHO;
            }
            break;
        case Vaciar:
            if ( pLst->empty() )
                cerr << ERR_V;
            else {
                char sn;
                cout << "\nOperaci\242n definitiva. \250Procedo? (s/n)";
                cin >> sn;

                if ( 'S' == toupper( sn ) ) {
                    pLst->clear();
                    cout << HECHO;
                } else
                    cout << "Abortado.\n\n";
            }
            break;
        }

        system( "pause" );
    }
}
