#ifndef CPA_H_INCLUDED
#define CPA_H_INCLUDED

//  cpa.h: definiciones para el programa 20
//  Fecha: 5/5/2020; 8:15 am
//  Revisin: 12/9/2020; 10:15 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;

//  tipificacin de mensajes
const Str HECHO( "\n\255Hecho!\n\n" );
const Str MSG_N( "\nNo est\240.\n\n" );
const Str MSG_V( "\nN\242mina vac\241a.\n\n" );
const Str MSG_Y( "\nYa est\240.\n\n" );
const Str ERR_L( "\nNo puedo leer el archivo.\n\n" );
const Str ERR_E( "\nNo puedo escribir al archivo.\n\n" );

#include <tuple>
//  nombre, apellido, horas
typedef std::tuple<Str, Str, int> Datos;

//  es una estructura que tiene el nombre completo
//  del obrero y las horas trabajadas en el mes.
//  sabe entrar sus datos y devolverlos
struct Obrero {
    bool yaEsta( Datos unDato );
    void entrarObrero( Str nombre, Str apellido, int horas );
    Datos sacarDatos();
    // miembro
    Datos dato;
};

#include <fstream>
#include <deque>
typedef std::deque<Obrero> Dek;
//  nombre, apellido
typedef std::pair<Str, Str> Par;

//  la CPA se encarga de manejar la nominilla en disco y de atender
//  los pedidos del men. Tiene un listado de sus obreros y es capaz
//  de calcularles el salario y poner la nmina a consola y a disco
struct CPA {
    void escribirNomina( std::ostream & escribe );
    void leerPlantilla( std::istream & lee );
    void adicionarObrero( Par dat );
    void editarObrero( Par dat );
    void borrarObrero( Par dat );
    double verDatos( Datos & d, std::ostream & escribe ) const;
    bool datoEsta( Par dat ) const;
    // miembro
    Dek nomina;
};

#endif // CPA_H_INCLUDED
