//  extras.cpp: definiciones para el programa 20
//  Fecha: 7/5/2020; 12:37 pm
//  Por: S. Galliano.
#include "extras.h"

//  funcin de ordenamiento fuerte: trabaja sobre los nodos
//  del contenedor, aade un nivel extra de indireccin
bool menor( const Obrero & n1, const Obrero & n2 ) {
    // hay que desempacar los valores a comparar
    // primer nodo
    Str nom1 = std::get<0>( n1.dato );
    Str ape1 = std::get<1>( n1.dato );
    // segundo nodo
    Str nom2 = std::get<0>( n2.dato );
    Str ape2 = std::get<1>( n2.dato );

    if ( ape1 < ape2 ) return true;
    else if ( ape1 == ape2 and nom1 < nom2 ) return true;
    else return false;
}

const int HORAS    =  40;  // a la semana
const int SEMANAS  =   4;  // 4 semanas por mes
const int PAGO     = 500;  // pesos
const float BASICO = static_cast<float>( PAGO ) / HORAS;
const float EXTRA  =   1.5 * BASICO;

//  funcin auxiliar: devuelve el salario devengado
float calcSalario( int hs ) {
    float salario;

    if ( hs > HORAS * SEMANAS ) {
        salario = ( hs - HORAS * SEMANAS ) * EXTRA;
        salario += HORAS * SEMANAS * BASICO;
    } else {
        salario = hs * BASICO;
    } // if-else

    return salario;
}

#include <iostream>

//  funcin auxiliar para cargar nombre y apellido
Par cargarDato() {
    Str nom, ape;
    std::cout << "\250Nombre? ";
    std::getline( std::cin, nom );
    std::cout << "\250Apellido? ";
    std::getline( std::cin, ape );

    return std::make_pair( nom, ape );
}
