// Programa 20: varios niveles de complejidad
// Fecha: 5/5/2020; 8:15 am
// Revisin: 12/9/2020; 10:15 am
// S. Galliano.

#include "menu.h"
#include "cpa.h"
#include "extras.h"
#include <iostream>
#include <cstdlib>

int main() {
    Str info( "Programa 20: n\242mina de la CPA Santos Garc\241a.\n\n" );
    std::ofstream aDisco( "C:/temp/BD/nomina.txt" );
    std::ifstream deDisco( "C:/temp/BD/plantilla.txt" );
    CPA * pLista = new CPA;
    int cant, opcion;
    char sn;

    while ( true ) {
        opcion = menu( info );

        if ( Terminar == opcion ) {
            delete pLista;
            return EXIT_SUCCESS;
        } else
            cant = pLista->nomina.size();

        switch ( opcion ) {
        case Contar:
            if ( 0 == cant )
                std::cerr << MSG_V;
            else
                1 == cant
                    ? std::cout << "\nUn registro.\n\n"
                    : std::cout << '\n' << cant << " registros.\n\n";
            break;
        case Insertar:
            pLista->adicionarObrero( cargarDato() );
            break;
        case Crear:
            try {
                pLista->escribirNomina( aDisco );
                pLista->escribirNomina( std::cout );
            } catch ( Str ) {
                std::cerr << ERR_E;
            } // try-catch
            break;
        case Checar:
            0 == cant
                ? std::cout << MSG_V
                : pLista->datoEsta( cargarDato() )
                    ? std::cout << MSG_Y
                    : std::cout << MSG_N;
            break;
        case Editar:
            if ( 0 == cant )
                std::cout << MSG_V;
            else
                pLista->editarObrero( cargarDato() );
            break;
        case Vaciar:
            if ( 0 == cant )
                std::cout << MSG_V;
            else {
                std::cout << "\nPara vaciar la n\242mina.\n\250Prosigo? (s/n) ";
                ( std::cin >> sn ).get();

                if ( 'S' == toupper( sn ) ) {
                    pLista->nomina.clear();
                    std::cout << HECHO;
                } else
                    std::cerr << "\nAcci\242n abortada.\n\n";
            } // if-else
            break;
        case Borrar:
            if ( 0 == cant )
                std::cout << MSG_V;
            else
                pLista->borrarObrero( cargarDato() );
            break;
        case Cargar:
            try {
                pLista->leerPlantilla( deDisco );
                std::cout << HECHO;
            } catch ( Str ) {
                std::cerr << ERR_L;
            } // try-catch
            break;
        } // switch
        system( "pause" );
    } // while
}
